use crate::{character::Character, combat::make_them_fight};

pub fn battle_stats(characters: Vec<Character>, enemies: Vec<Character>) -> (f64, f64) {
    let mut a = 1.0;
    let mut b = 1.0;

    let mut total_turns = 0.0;
    let mut battles = 0.0;

    let mut chars: Vec<Character> = characters.iter().map(|c| c.clone()).collect();
    let mut enms: Vec<Character> = enemies.iter().map(|c| c.clone()).collect();

    loop {
        if let Some(turns) = make_them_fight(chars.iter_mut().collect(), enms.iter_mut().collect())
        {
            battles += 1.0;
            total_turns += turns as f64;

            if chars.iter().all(|c| c.is_dead()) {
                b += 1.0;
                log::trace!("Bob died in {} turns.", turns)
            } else {
                a += 1.0;
                log::trace!("Bandit died in {} turns.", turns)
            }

            if (a * b) / (f64::powi(a + b, 2) * (a + b + 1.0)) <= 0.0001 {
                break;
            }
        } else {
            log::trace!("No one died.")
        }
    }

    (a / (a + b) * 100.0, total_turns / battles)
}
